﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BinPlayerTrigger : MonoBehaviour
{
    [SerializeField] private SockBin _sockBin;

    private bool _open;

    private void Awake()
    {
        _sockBin = GetComponentInParent<SockBin>();
    }

    private void OnTriggerEnter(Collider other)
    {
        Debug.Log(other.gameObject.name);
        var player = other.GetComponentInParent<BasicPlayerMovement>();
        if (player != null)
        {
            player.SetSockPlacement(_sockBin);
        }
    }

    private void OnTriggerExit(Collider other)
    {
        var player = other.GetComponentInParent<BasicPlayerMovement>();
        if (player != null)
        {
            player.SetSockPlacement(null);
        }
    }
}
