﻿using System.Collections;
using System.Linq;
using UnityEngine;

public class SockBin : MonoBehaviour
{
    [SerializeField] private Animation _animation;
    [SerializeField] private ParticleSystem SockColorConfetti;
    [SerializeField] private ParticleSystem MultiColorConfetti;

    private GameManager _gameManager;

    private void Awake()
    {
        _gameManager = GameObject.Find("GameManager").GetComponent<GameManager>();
    }

    //public void PlaceSock(SockHoldPosition sock)
    //{
    //    var unplaced = _sockPlaceRenderers.First(p => !p.gameObject.activeSelf);
    //    unplaced.material = sock.GetSock().SockMaterial;
    //    unplaced.gameObject.SetActive(true);
    //    if (_sockPlaceRenderers.All(p => p.gameObject.activeSelf))
    //    {
    //        CheckSockResult();
    //    }
        
    //    _gameManager.RemoveSock(sock.GetSock());
    //}

    
    public void CheckSockResult(SockBehaviour a, SockBehaviour b, int playerNumber)
    {
        //a.transform.parent = null;
        //b.transform.parent = null;
        if (a.SockMaterial == b.SockMaterial)
        {
            var main = SockColorConfetti.main;
            main.startColor = a.SockMaterial.color;
            SockColorConfetti.Play();
            MultiColorConfetti.Play();

            _animation.Play();
            _gameManager.OnPointScored(playerNumber);
            _gameManager.RemoveSock(a);
            _gameManager.RemoveSock(b);
        }
        else
        {
            StartCoroutine(_gameManager.RecreateSock(a.SockMaterial));
            StartCoroutine(_gameManager.RecreateSock(b.SockMaterial)); 
        }
    }
}
