﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SockSpawner : MonoBehaviour
{
    [SerializeField] private GameManager _gameManager;
    public int NumSocks;
    public float SpawnInterval;
    public GameObject SockObject;
    public Material[] SockMaterial;

    public List<SockBehaviour> CreatedSocks = new List<SockBehaviour>();
    public bool AutoStart;

    private void Start()
    {
        if (AutoStart)
        {
            StartCoroutine(CreateSocks());
        }
    }

    public IEnumerator CreateSocks()
    {
        // create socks in pairs
        CreatedSocks = new List<SockBehaviour>();
        for (var i = 0; i<NumSocks; i+=2)
        {
            yield return new WaitForSeconds(SpawnInterval);

            var sock1 = Instantiate(SockObject, transform.position, Quaternion.identity, this.transform).GetComponentInChildren<SockBehaviour>();
            var sock2 = Instantiate(SockObject, transform.  position, Quaternion.identity, this.transform).GetComponentInChildren<SockBehaviour>();
            var index = UnityEngine.Random.Range(0, SockMaterial.Length);

            sock1.SetMaterial(SockMaterial[index]);
            sock2.SetMaterial(SockMaterial[index]);

            CreatedSocks.Add(sock1);
            CreatedSocks.Add(sock2);
        }
    }

    public IEnumerator CreateSock(Material mat)
    {
        CreatedSocks = new List<SockBehaviour>();
        yield return new WaitForSeconds(SpawnInterval);
        var rotation = Quaternion.Euler(Random.Range(0f, 1f), Random.Range(0f, 1f), Random.Range(0f, 1f));
        var sock = Instantiate(SockObject, transform.position, rotation, this.transform).GetComponentInChildren<SockBehaviour>();

        sock.SetMaterial(mat);

        CreatedSocks.Add(sock);
    }

}
